# all files / src/ Dialog.js

76.25% Statements 61/80
28% Branches 7/25
66.67% Functions 12/18
76.25% Lines 61/80

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247
    248
    249
    250
    251
    252
    253
    254
    255
    256
    257
    258
    259
    260
    261
    262
    263
    264
    265
    266
    267
    268
    269
    270
    271
    272
    273
    274
    275
    276
    277
    278
    279
    280
    281
    282
    283
    284
    285
    286
    287
    288
    289
    290
    291
    292
    293
    294
    295
    296
    297
    298
    299
    300
    301
    302
    303
    304
    305
    306
    307
    308
    309
    310
    311
    312
    313
    314
    315
    316
    317
    318
    319
    320
    321
    322
    323
    324
    325
    326
    327
    328
    329
    330
    331
    332
    333
    334
    335
    336
    337
    338
    339
    340
    341
    342
    343

    1×

    1×

    1×

    1×
    1×
    1×
    1×

    1×

    1×

    1×
    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×
    10×
    10×
    5×
    5×

    1×

    1×

    1×
    5×

    5×

    5×

    5×
    5×

    5×

    1×

    5×

    5×

    5×
    5×

    1×

    1×

    1×

    1×
    1×
    1×

    1×
    5×
    5×
    9×

    5×

    1×
    9×

    1×

    1×

    5×

    1×
    10×

    10×
    9×

    10×

    1×
    5×
    5×
    5×

     /**
     * The Dialog class serves as the base class for the other types of dialogs.
     * Unless extended to include controls, the rendered dialog box is a simple window
     * that users can close by hitting the ‘Esc’ key. Dialog windows are used with OO.ui.WindowManager,
     * which opens, closes, and controls the presentation of the window. See the
     * [OOUI documentation on MediaWiki] [1] for more information.
     *
     *     @example
     *     // A simple dialog window.
     *     function MyDialog( config ) {
     *         MyDialog.parent.call( this, config );
     *     }
     *     OO.inheritClass( MyDialog, OO.ui.Dialog );
     *     MyDialog.static.name = 'myDialog';
     *     MyDialog.prototype.initialize = function () {
     *         MyDialog.parent.prototype.initialize.call( this );
     *         this.content = new OO.ui.PanelLayout( { padded: true, expanded: false } );
     *         this.content.$element.append( '<p>A simple dialog window. Press \'Esc\' to close.</p>' );
     *         this.$body.append( this.content.$element );
     *     };
     *     MyDialog.prototype.getBodyHeight = function () {
     *         return this.content.$element.outerHeight( true );
     *     };
     *     var myDialog = new MyDialog( {
     *         size: 'medium'
     *     } );
     *     // Create and append a window manager, which opens and closes the window.
     *     var windowManager = new OO.ui.WindowManager();
     *     $( 'body' ).append( windowManager.$element );
     *     windowManager.addWindows( [ myDialog ] );
     *     // Open the window!
     *     windowManager.openWindow( myDialog );
     *
     * [1]: https://www.mediawiki.org/wiki/OOUI/Windows/Dialogs
     *
     * @abstract
     * @class
     * @extends OO.ui.Window
     * @mixins OO.ui.mixin.PendingElement
     *
     * @constructor
     * @param {Object} [config] Configuration options
     */
    OO.ui.Dialog = function OoUiDialog( config ) {
    	// Parent constructor
    	OO.ui.Dialog.parent.call( this, config );

    	// Mixin constructors
    	OO.ui.mixin.PendingElement.call( this );

    	// Properties
    	this.actions = new OO.ui.ActionSet();
    	this.attachedActions = [];
    	this.currentAction = null;
    	this.onDialogKeyDownHandler = this.onDialogKeyDown.bind( this );

    	// Events
    	this.actions.connect( this, {
    		click: 'onActionClick',
    		change: 'onActionsChange'
    	} );

    	// Initialization
    	this.$element
    		.addClass( 'oo-ui-dialog' )
    		.attr( 'role', 'dialog' );
    };

    /* Setup */

    OO.inheritClass( OO.ui.Dialog, OO.ui.Window );
    OO.mixinClass( OO.ui.Dialog, OO.ui.mixin.PendingElement );

    /* Static Properties */

    /**
     * Symbolic name of dialog.
     *
     * The dialog class must have a symbolic name in order to be registered with OO.Factory.
     * Please see the [OOUI documentation on MediaWiki] [3] for more information.
     *
     * [3]: https://www.mediawiki.org/wiki/OOUI/Windows/Window_managers
     *
     * @abstract
     * @static
     * @inheritable
     * @property {string}
     */
    OO.ui.Dialog.static.name = '';

    /**
     * The dialog title.
     *
     * The title can be specified as a plaintext string, a {@link OO.ui.mixin.LabelElement Label} node, or a function
     * that will produce a Label node or string. The title can also be specified with data passed to the
     * constructor (see #getSetupProcess). In this case, the static value will be overridden.
     *
     * @abstract
     * @static
     * @inheritable
     * @property {jQuery|string|Function}
     */
    OO.ui.Dialog.static.title = '';

    /**
     * An array of configured {@link OO.ui.ActionWidget action widgets}.
     *
     * Actions can also be specified with data passed to the constructor (see #getSetupProcess). In this case, the static
     * value will be overridden.
     *
     * [2]: https://www.mediawiki.org/wiki/OOUI/Windows/Process_Dialogs#Action_sets
     *
     * @static
     * @inheritable
     * @property {Object[]}
     */
    OO.ui.Dialog.static.actions = [];

    /**
     * Close the dialog when the 'Esc' key is pressed.
     *
     * @static
     * @abstract
     * @inheritable
     * @property {boolean}
     */
    OO.ui.Dialog.static.escapable = true;

    /* Methods */

    /**
     * Handle frame document key down events.
     *
     * @private
     * @param {jQuery.Event} e Key down event
     */
    OO.ui.Dialog.prototype.onDialogKeyDown = function ( e ) {
    	var actions;
    	if ( e.which === OO.ui.Keys.ESCAPE && this.constructor.static.escapable ) {
    		this.executeAction( '' );
    		e.preventDefault();
    		e.stopPropagation();
    	} else if ( e.which === OO.ui.Keys.ENTER && ( e.ctrlKey || e.metaKey ) ) {
    		actions = this.actions.get( { flags: 'primary', visible: true, disabled: false } );
    		if ( actions.length > 0 ) {
    			this.executeAction( actions[ 0 ].getAction() );
    			e.preventDefault();
    			e.stopPropagation();
    		}
    	}
    };

    /**
     * Handle action click events.
     *
     * @private
     * @param {OO.ui.ActionWidget} action Action that was clicked
     */
    OO.ui.Dialog.prototype.onActionClick = function ( action ) {
    	if ( !this.isPending() ) {
    		this.executeAction( action.getAction() );
    	}
    };

    /**
     * Handle actions change event.
     *
     * @private
     */
    OO.ui.Dialog.prototype.onActionsChange = function () {
    	this.detachActions();
    	if ( !this.isClosing() ) {
    		this.attachActions();
    		Iif ( !this.isOpening() ) {
    			// If the dialog is currently opening, this will be called automatically soon.
    			this.updateSize();
    		}
    	}
    };

    /**
     * Get the set of actions used by the dialog.
     *
     * @return {OO.ui.ActionSet}
     */
    OO.ui.Dialog.prototype.getActions = function () {
    	return this.actions;
    };

    /**
     * Get a process for taking action.
     *
     * When you override this method, you can create a new OO.ui.Process and return it, or add additional
     * accept steps to the process the parent method provides using the {@link OO.ui.Process#first 'first'}
     * and {@link OO.ui.Process#next 'next'} methods of OO.ui.Process.
     *
     * @param {string} [action] Symbolic name of action
     * @return {OO.ui.Process} Action process
     */
    OO.ui.Dialog.prototype.getActionProcess = function ( action ) {
    	return new OO.ui.Process()
    		.next( function () {
    			if ( !action ) {
    				// An empty action always closes the dialog without data, which should always be
    				// safe and make no changes
    				this.close();
    			}
    		}, this );
    };

    /**
     * @inheritdoc
     *
     * @param {Object} [data] Dialog opening data
     * @param {jQuery|string|Function|null} [data.title] Dialog title, omit to use
     *  the {@link #static-title static title}
     * @param {Object[]} [data.actions] List of configuration options for each
     *   {@link OO.ui.ActionWidget action widget}, omit to use {@link #static-actions static actions}.
     */
    OO.ui.Dialog.prototype.getSetupProcess = function ( data ) {
    	data = data || {};

    	// Parent method
    	return OO.ui.Dialog.parent.prototype.getSetupProcess.call( this, data )
    		.next( function () {
    			var config = this.constructor.static,
    				actions = data.actions !== undefined ? data.actions : config.actions,
    				title = data.title !== undefined ? data.title : config.title;

    			this.title.setLabel( title ).setTitle( title );
    			this.actions.add( this.getActionWidgets( actions ) );

    			this.$element.on( 'keydown', this.onDialogKeyDownHandler );
    		}, this );
    };

    /**
     * @inheritdoc
     */
    OO.ui.Dialog.prototype.getTeardownProcess = function ( data ) {
    	// Parent method
    	return OO.ui.Dialog.parent.prototype.getTeardownProcess.call( this, data )
    		.first( function () {
    			this.$element.off( 'keydown', this.onDialogKeyDownHandler );

    			this.actions.clear();
    			this.currentAction = null;
    		}, this );
    };

    /**
     * @inheritdoc
     */
    OO.ui.Dialog.prototype.initialize = function () {
    	// Parent method
    	OO.ui.Dialog.parent.prototype.initialize.call( this );

    	// Properties
    	this.title = new OO.ui.LabelWidget();

    	// Initialization
    	this.$content.addClass( 'oo-ui-dialog-content' );
    	this.$element.attr( 'aria-labelledby', this.title.getElementId() );
    	this.setPendingElement( this.$head );
    };

    /**
     * Get action widgets from a list of configs
     *
     * @param {Object[]} actions Action widget configs
     * @return {OO.ui.ActionWidget[]} Action widgets
     */
    OO.ui.Dialog.prototype.getActionWidgets = function ( actions ) {
    	var i, len, widgets = [];
    	for ( i = 0, len = actions.length; i < len; i++ ) {
    		widgets.push( this.getActionWidget( actions[ i ] ) );
    	}
    	return widgets;
    };

    /**
     * Get action widget from config
     *
     * Override this method to change the action widget class used.
     *
     * @param {Object} config Action widget config
     * @return {OO.ui.ActionWidget} Action widget
     */
    OO.ui.Dialog.prototype.getActionWidget = function ( config ) {
    	return new OO.ui.ActionWidget( this.getActionWidgetConfig( config ) );
    };

    /**
     * Get action widget config
     *
     * Override this method to modify the action widget config
     *
     * @param {Object} config Initial action widget config
     * @return {Object} Action widget config
     */
    OO.ui.Dialog.prototype.getActionWidgetConfig = function ( config ) {
    	return config;
    };

    /**
     * Attach action actions.
     *
     * @protected
     */
    OO.ui.Dialog.prototype.attachActions = function () {
    	// Remember the list of potentially attached actions
    	this.attachedActions = this.actions.get();
    };

    /**
     * Detach action actions.
     *
     * @protected
     * @chainable
     */
    OO.ui.Dialog.prototype.detachActions = function () {
    	var i, len;

    	// Detach all actions that may have been previously attached
    	for ( i = 0, len = this.attachedActions.length; i < len; i++ ) {
    		this.attachedActions[ i ].$element.detach();
    	}
    	this.attachedActions = [];
    };

    /**
     * Execute an action.
     *
     * @param {string} action Symbolic name of action to execute
     * @return {jQuery.Promise} Promise resolved when action completes, rejected if it fails
     */
    OO.ui.Dialog.prototype.executeAction = function ( action ) {
    	this.pushPending();
    	this.currentAction = action;
    	return this.getActionProcess( action ).execute()
    		.always( this.popPending.bind( this ) );
    };